<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px" @submit.native.prevent>
      <el-form-item label="类型" prop="typeId">
        <template>
          <el-select v-model="queryParams.typeId" filterable placeholder="请选择">
            <el-option
              v-for="item in buildingTypeList"
              :key="item.typeId"
              :label="item.typeName"
              :value="item.typeId">
            </el-option>
          </el-select>
        </template>
      </el-form-item>
      <el-form-item label="大楼名称" prop="buildingName">
        <el-input
          v-model="queryParams.buildingName"
          placeholder="请输入大楼名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['info:buildingInfo:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['info:buildingInfo:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['info:buildingInfo:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          :loading="exportLoading"
          @click="handleExport"
          v-hasPermi="['info:buildingInfo:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="buildingInfoList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="大楼编号" align="center" prop="buildingId" />
      <el-table-column label="类型" align="center" prop="typeName" />
      <el-table-column label="大楼名称" align="center" prop="buildingName" />
      <el-table-column label="二维坐标" align="center" prop="lngLat" />
      <el-table-column label="三维坐标" align="center" prop="rasterLngLat" />
      <el-table-column label="户数" align="center" prop="households" />
      <el-table-column label="面积" align="center" prop="acreage" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" width="140">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['info:buildingInfo:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['info:buildingInfo:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改大楼信息对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="800px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="类型" prop="typeId">
          <template>
            <el-select v-model="form.typeId" filterable placeholder="请选择">
              <el-option
                v-for="item in buildingTypeList"
                :key="item.typeId"
                :label="item.typeName"
                :value="item.typeId">
              </el-option>
            </el-select>
          </template>
        </el-form-item>
        <el-form-item label="大楼名称" prop="buildingName">
          <el-input v-model="form.buildingName" placeholder="请输入大楼名称" />
        </el-form-item>
        <el-form-item label="楼栋号" prop="mapCode">
          <el-input-number v-model="form.mapCode" controls-position="right"   :min="0" placeholder="请输入楼栋号" />
        </el-form-item>

        <el-form-item label="英文名称" prop="enName">
          <el-input v-model="form.enName" placeholder="请输入英文名称" />
        </el-form-item>
        <el-form-item label="别名" prop="alias">
          <el-input v-model="form.alias" placeholder="请输入别名" />
        </el-form-item>
        <el-form-item label="排序" prop="orderId">
          <el-input-number v-model="form.orderId" controls-position="right"   :min="0" placeholder="请输入排序" />
        </el-form-item>

        <el-form-item label="是否已同步">
          <el-switch v-model="form.synStatus"></el-switch>
        </el-form-item>
        <el-form-item label="简介" prop="brief">
          <el-input v-model="form.brief" placeholder="请输入简介" />
        </el-form-item>
        <el-form-item label="二维坐标" prop="lngLat">
          <el-input v-model="form.lngLat" placeholder="请输入二维坐标" />
        </el-form-item>
        <el-form-item label="招商简介" prop="memo">
          <div v-if="open">
            <wang-editor v-model="form.memo" :min-height="140" />
          </div>
        </el-form-item>
        <el-form-item label="三维坐标" prop="rasterLngLat">
          <el-input v-model="form.rasterLngLat" @focus="openditu">
            {{ form.rasterLngLat}}
          </el-input>
        </el-form-item>
        <el-form-item label="地址" prop="address">
          <el-input v-model="form.address" placeholder="请输入地址" />
        </el-form-item>
        <el-form-item label="高度" prop="height">
          <el-input-number v-model="form.height" controls-position="right"   :min="0" placeholder="请输入高度" />
        </el-form-item>

        <el-form-item label="楼层数" prop="levelNumber">
          <el-input-number v-model="form.levelNumber" controls-position="right"   :min="0" placeholder="请输入楼层数" />
        </el-form-item>

        <el-form-item label="户数" prop="households">
          <el-input-number v-model="form.households" controls-position="right"   :min="0" placeholder="请输入户数" />
        </el-form-item>

        <el-form-item label="面积" prop="acreage">
          <el-input-number v-model="form.acreage" controls-position="right"   :min="0" placeholder="请输入面积" />
        </el-form-item>

      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

    <el-dialog title="地图" :visible.sync="dialogVisible" width="80%">
      <div id='mainMap'>
        <div id="mapDiv" style="width:100%; height:700px">
        </div>
      </div>
      <input type="button" value="清除" @click='clearmian()' />
      <input type="button" value="标点工具" @click='openMarkTool()' />
      <span slot="footer" class="dialog-footer">
        <el-button @click="dialogVisible = false">取 消</el-button>
        <el-button type="primary" @click='tijiao'>确定</el-button>
      </span>
    </el-dialog>
  </div>
</template>

<script>
import { listBuildingInfo, getBuildingInfo, delBuildingInfo, addBuildingInfo, updateBuildingInfo, exportBuildingInfo } from "@/api/info/buildingInfo";
import { listBuildingType, getBuildingType } from "@/api/type/buildingType";
export default {
  name: "BuildingInfo",
  data() {
    return {
      dialogVisible: false,
      map: null,
      handler: null,
      markPoints: '', // 保存标记点的坐标
      buildingTypeList: [],
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 大楼信息表格数据
      buildingInfoList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        typeId: null,
        buildingName: null,
      },
      queryBuildingTypeParams: {
        pageNum: 1,
        pageSize: 9999,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        buildingId: [
          { required: true, message: "大楼编号不能为空", trigger: "blur" }
        ],
        typeId: [
          { required: true, message: "类别不能为空", trigger: "change" }
        ],
      }
    };
  },
  created() {
    this.getList();
    this.getBuildingTypeList();
  },
  methods: {

    // 销毁天地图
    destructionTMap ()  {
      if (this.map) {
        this.map = null;
        // 直接将节点给删掉
        console.log('1qsad');

        const parentEl = document.getElementById('mainMap');
        const cahildrenEl1 = document.getElementById('mapDiv');
        if(cahildrenEl1) parentEl.removeChild(cahildrenEl1);
        // 然后再手动将节点加进来
        const newCahildrenEl = document.createElement("div");
        newCahildrenEl.id = 'mapDiv'
        newCahildrenEl.style = 'height: 700px;width: 100%;'
        parentEl.appendChild(newCahildrenEl)
      }
    },

    tijiao() {
      console.log('多边形数据:', this.form.rasterLngLat);
      console.log('多边形数据:', this.markPoints);
      this.form.rasterLngLat = this.markPoints
      this.destructionTMap()
      this.dialogVisible = false;
    },

    clearmian() {
      if (this.handler) this.handler.close();
      this.map.clearOverLays(); // 清除所有覆盖物
      this.markPoints = ''; // 清除保存的标记点坐标
    },

    openMarkTool() {
      console.log("1111111111")
      if (this.handler) this.handler.close(); // 关闭之前的工具

      this.handler = new T.MarkTool(this.map); // 创建标点工具
      this.handler.open(); // 打开标点工具

      this.handler.on("mouseup", (e) => {
        let drawData1 = e.currentLnglat.lat+","+e.currentLnglat.lng;
        this.markPoints = drawData1;
      });

      this.handler.on("close", () => {
        // 标点工具关闭时的处理
        this.handler = null;
      });
    },


    openditu() {
      console.log('打开地图对话框');
      this.dialogVisible = true;
      this.$nextTick(() => {
        const T = window.T;
        const zoom = 12;
        this.map = new T.Map('mapDiv');
        this.map.centerAndZoom(new T.LngLat(103.96, 30.66), zoom);
        // 创建标注工具对象
        this.handler = new T.MarkTool(this.map);
        console.log('handler 初始化完成:', this.handler);
        console.log('kanknak1', this.form.rasterLngLat);
        let points = new T.LngLat();
        if (this.form.rasterLngLat) {
          const coordinates = this.form.rasterLngLat.split(',');
          points =  new T.LngLat(coordinates[1], coordinates[0]);
        }
        // 创建面对象
        console.log('kanknak2', points);
        const marker = new T.Marker(points);
        // 向地图上添加面
        this.map.addOverLay(marker);
      });
    },

    getBuildingTypeList() {
      listBuildingType(this.queryBuildingTypeParams).then(response => {
      this.buildingTypeList = response.data.list;
      });
    },
    /** 查询大楼信息列表 */
    getList() {
      this.loading = true;
      listBuildingInfo(this.queryParams).then(response => {
        this.buildingInfoList = response.data.list;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        buildingId: null,
        typeId: null,
        buildingName: null,
        mapCode: null,
        enName: null,
        alias: null,
        orderId: null,
        synStatus: true,
        delete: true,
        brief: null,
        lngLat: null,
        memo: null,
        rasterLngLat: null,
        address: null,
        height: null,
        levelNumber: null,
        households: null,
        acreage: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.buildingId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加大楼信息";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const buildingId = row.buildingId || this.ids
      getBuildingInfo(buildingId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改大楼信息";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.buildingId != null) {
            updateBuildingInfo(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addBuildingInfo(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const buildingIds = row.buildingId || this.ids;
      this.$modal.confirm('是否确认删除大楼信息编号为"' + buildingIds + '"的数据项？').then(function() {
        return delBuildingInfo(buildingIds);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$modal.confirm('是否确认导出所有大楼信息数据项？').then(() => {
        this.exportLoading = true;
        return exportBuildingInfo(queryParams);
      }).then(response => {
        this.$download.name(response.msg);
        this.exportLoading = false;
      }).catch(() => {});
    }
  }
};
</script>
